﻿package  
{
	import com.kevinhoyt.components.*;	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.*;
	import flash.events.MouseEvent;
	import flash.utils.ByteArray;
    import flash.events.StatusEvent;
    import flash.events.TimerEvent;
    import flash.media.Camera;
    import flash.media.Video;
	import flash.utils.Timer;    
    

    /**
     * Document class for SnapAPic application. 
     * AIR for Android sample app 
     *  
     * @author Rich Wagner
     * 
     */    
    public class LiveFeed extends Sprite 
	{
		private var ftr:Footer;
		private var ttl:Title;
        private var lbl:Label; 
        private var camera:Camera;
        private var timer:Timer;    

        /**
         * Constructor  
         * 
         */
		public function LiveFeed() 
		{
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;
            
            ttl = new Title( "Live Feed" );
            addChild( ttl );
            
            lbl = new Label( "" );
            lbl.x = 9;
            lbl.y = 52;
            addChild( lbl );            
                        
            
            // Camera support?              
            if (Camera.isSupported)
            {
                timer = new Timer(1000); 
                timer.addEventListener(TimerEvent.TIMER, timerHandler);
                
                camera = Camera.getCamera();
                displayCamera(); 
                
                timer.start();
            }
            else
            {
                lbl.text = "Camera is not supported on this device.";
            }                  
            
		}
		

        /**
         * Displays camera  
         *  
         */        
        private function displayCamera():void 
        {
            // Create a video object, enhancing its normal size to fill more of the screen 
            var video:Video = new Video(camera.width*2.6, camera.height*2.6);
            video.x = 320;
            video.y = 52;
            video.attachCamera(camera);
            video.smoothing = true; 
            addChild(video);    
        }

        /**
         * Listener for timer routine  
         *  
         * @param event
         * 
         */       
        private function timerHandler(event:TimerEvent):void 
        {
            lbl.text = "Camera Specifications:" + "\n" + 
            "activityLevel: " + camera.activityLevel + "\n" + 
            "bandwidth: " + camera.bandwidth + "\n" + 
            "currentFPS: " + Math.round(camera.currentFPS) + "\n" + 
            "fps: " + camera.fps + "\n" + 
            "height: " + camera.height + "\n" + 
            "index: " + camera.index + "\n" + 
            "keyFrameInterval: " + camera.keyFrameInterval + "\n" + 
            "loopback: " + camera.loopback + "\n" + 
            "motionlevel: " + camera.motionLevel + "\n" + 
            "muted: " + camera.muted+ "\n" + 
            "name: " + camera.name + "\n" + 
            "quality: " + camera.quality+ "\n" + 
            "width: " + camera.width + "\n"; 
        }
    }

        
}
