﻿package  
{
  // Download from http://kevinhoyt.org/
	import com.kevinhoyt.components.*; 
	
	import flash.display.Sprite;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	import flash.events.MouseEvent;
    import flash.media.CameraUI;
    import flash.media.MediaType; 
    import flash.display.SimpleButton;
    import flash.events.*;
    import flash.text.TextFormat;
    import flash.text.TextField;
    import flash.filesystem.File;

    /**
     * Document class for SnapAPic application. 
     * AIR for Android sample app 
     *  
     * @author Rich Wagner
     * 
     */    	
	public class SnapAPic extends Sprite 
	{
		private var btn:Button;
		private var ftr:Footer;
		private var lbl:Label;
		private var ttl:Title;
		private var txt:TextInput;
        private var cameraUI:CameraUI; 
        
        /**
         * Constructor  
         * 
         */        
		public function SnapAPic() 
		{
            
            super(); 
            
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;
            
            ttl = new Title( "SnapAPic" );
            addChild( ttl );
            
            lbl = new Label( "Click a button to snap a picture/video" );
            lbl.x = 9;
            lbl.y = 52;
            addChild( lbl );
            
            ftr = new Footer( "Image", "Video" );
            ftr.y = 683;
            addChild( ftr );
            
		
            // Camera support?              
            if (CameraUI.isSupported)
            {
                cameraUI = new CameraUI();
                cameraUI.addEventListener(MediaEvent.COMPLETE, mediaCompleteHandler);
                cameraUI.addEventListener(ErrorEvent.ERROR, errorHandler);
                cameraUI.addEventListener(Event.CANCEL, errorHandler);				
                
                ftr.addEventListener(FooterEvent.OK, imageButtonClickHandler); 
                ftr.addEventListener(FooterEvent.CANCEL, videoButtonClickHandler); 
                
            }
            else
            {
                lbl.text = "Unable to access Camera.";
            }        			        
        
		}
		

        /**
         * Launches the image camera   
         * 
         * @param event
         * 
         */        
        private function imageButtonClickHandler(event:FooterEvent):void
        {
            cameraUI.launch(MediaType.IMAGE); 	
        }     		

        /**
         * Launches the video camera   
         * 
         * @param event
         * 
         */        
        private function videoButtonClickHandler(event:FooterEvent):void
        {
            cameraUI.launch(MediaType.VIDEO); 	
        }     		
        
        /**
         * Displays media file name in the label     
         * 
         * @param event
         * 
         */        
        private function mediaCompleteHandler(event:MediaEvent):void
        {
            var file:File = event.data.file
            lbl.text = file.url; 			
        }

        /**
         * Displays error details      
         * 
         * @param event
         * 
         */        
        public function errorHandler(event:Event):void 
        {
            lbl.text = event.type;
        }		
        


		
	}
}
