﻿package  
{
	import com.kevinhoyt.components.*;
	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.*;
	import flash.events.MouseEvent;
	import flash.events.SampleDataEvent;
	import flash.media.MediaType;
	import flash.media.Microphone;
	import flash.media.Sound;
	import flash.utils.ByteArray;
	
	
    /**
     * Document class for LiveFeed application. 
     * iPhone Development with Flash sample app 
     *  
     * @author Rich Wagner
     * 
     */    		
	public class SpeakItHearIt extends Sprite 
	{
		private var ftr:Footer;
		private var ttl:Title;
        private var lbl:Label; 
        private var microphone:Microphone; 
        private var soundBytes:ByteArray;

        /**
         * Constructor  
         * 
         */
		public function SpeakItHearIt() 
		{
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;

            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;
            
            ttl = new Title( "SpeakItHearIt" );
            addChild( ttl );
            
            lbl = new Label( "Record something, then hear it" );
            lbl.x = 9;
            lbl.y = 52;
            addChild( lbl );            
                        
            ftr = new Footer( "Speak It", "Hear It" );
            ftr.y = 683;
            ftr.addEventListener(FooterEvent.OK, speakItHandler); 
            ftr.addEventListener(FooterEvent.CANCEL, hearItHandler); 
            addChild( ftr );
            
            // Camera support?              
            if (Microphone.isSupported)
            {
                microphone = Microphone.getMicrophone();
                microphone.setSilenceLevel(0, 4000);
                microphone.gain = 100;
                microphone.rate = 44;
                soundBytes= new ByteArray();
                lbl.text = "Ready to record and play"; 
            }
            else
            {
                lbl.text = "Unable to access Microphone.";
            }                  

            
		}
		
        
        /**
         * Called when Speak button is clicked 
         *  
         * @param event
         * 
         */   
		private function speakItHandler(event:FooterEvent):void
        {
            microphone.addEventListener(SampleDataEvent.SAMPLE_DATA, sampleDataHandler)        
        }
        
		
        /**
         * Called when Hear button is clicked 
         *  
         * @param event
         * 
         */   		
        private function hearItHandler(event:FooterEvent):void
        {
            microphone.removeEventListener(SampleDataEvent.SAMPLE_DATA, sampleDataHandler);
            soundBytes.position = 0;
            var sound:Sound = new Sound();
            sound.addEventListener(SampleDataEvent.SAMPLE_DATA, playbackSampleHandler);
            sound.play();            
        }
        
		
        /**
         * Begins recording session 
         *  	
         * @param event
         * 
         */   		
        private function sampleDataHandler(event:SampleDataEvent):void
        {
            while(event.data.bytesAvailable)
            {
                var sample:Number = event.data.readFloat();
                soundBytes.writeFloat(sample);
            }
        }

        /**
         * Plays back audio data in stored in memory  
         *  
         * @param event
         * 
         */   
        private function playbackSampleHandler(event:SampleDataEvent):void
        {
            for (var i:int = 0; i < 8192 && soundBytes.bytesAvailable > 0; i++) 
            {
                var sample:Number = soundBytes.readFloat();
                event.data.writeFloat(sample);
                event.data.writeFloat(sample);
            }
        }
                
	}
}
