﻿package  {
	
	import flash.display.MovieClip;

	// Events 
	import flash.events.MouseEvent;
	import flash.events.IOErrorEvent; 
	import flash.events.Event; 

	// Minimal Comps components
	// Download from http://www.minimalcomps.com/ 
	import com.bit101.components.PushButton; 
	import com.bit101.components.TextArea; 
	
	// File-related 
	import flash.filesystem.File; 
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream; 

	// Stage setup 
	import flash.display.StageAlign;
    import flash.display.StageScaleMode;

	public class Jots extends MovieClip {

        private var ta:TextArea; 		
		private var openBtn:PushButton; 
		private var saveBtn:PushButton; 		
		public var file:File; 		

		public function Jots() {

			// Set up the stage 
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;

            // Create TextField         
            ta = new TextArea();
			ta.x = 10;
            ta.y = 10;
            ta.height = stage.stageHeight - 120;
            ta.width = stage.stageWidth - 20;
            addChild(ta);			
			
			// Create Open button 
			openBtn = new PushButton(); 
			openBtn.label = "Open"; 
			openBtn.x = 10; 
			openBtn.y = stage.stageHeight - 100; 
			openBtn.height = 70; 
			openBtn.width = 200; 
			openBtn.addEventListener(MouseEvent.CLICK, openBtnClickHandler); 
            addChild(openBtn);			

			// Create Save button 
			saveBtn = new PushButton(); 
			saveBtn.label = "Save"; 
			saveBtn.x = 240; 
			saveBtn.y = stage.stageHeight - 100; 
			saveBtn.height = 70; 
			saveBtn.width = 200; 
			saveBtn.addEventListener(MouseEvent.CLICK, saveBtnClickHandler);
			addChild(saveBtn);			

			// Create pointer to file 
			file = File.applicationStorageDirectory.resolvePath("MyDataFile.txt"); 

		
		}
		
		private function openBtnClickHandler(event:MouseEvent):void
		{
			var fileStream:FileStream = new FileStream();
			fileStream.openAsync(file, FileMode.READ);
			fileStream.addEventListener(Event.COMPLETE, completeHandler);
			fileStream.addEventListener(IOErrorEvent.IO_ERROR, ioReadErrorHandler);
      	}
      
		  private function completeHandler(event:Event):void 
		  {
				var fileStream:FileStream = event.target as FileStream;  
				var str:String = fileStream.readUTFBytes(fileStream.bytesAvailable);
				ta.text = str; 
				fileStream.close(); 
		  }      
	
		  private function ioReadErrorHandler(event:Event):void 
		  {
			trace("Unable to open" + file.nativePath);
		  }
	
	      private function saveBtnClickHandler(event:MouseEvent):void
		  {
				var fileStream:FileStream = new FileStream(); 
				fileStream.openAsync(file, FileMode.WRITE);
				fileStream.addEventListener(IOErrorEvent.IO_ERROR, onIOWriteError);
				var str:String = ta.text;
				str = str.replace(/\r/g, "\n");
				str = str.replace(/\n/g, File.lineEnding);
				fileStream.writeUTFBytes(str);
				fileStream.close();
		  }           
	

		  private function ioWriteErrorHandler(event:Event):void 
		  { 
			trace("Unable to save");
		  }		
		
		
	}
	
}
