package
{
    import flash.display.MovieClip;
    import flash.events.AccelerometerEvent;
    import flash.sensors.Accelerometer;
    import flash.text.*;    
    import flash.display.*;

    /**
     * Document class for AccelerateInfo application. 
     * iPhone Development with Flash sample app 
     *  
     * @author Rich Wagner
     * 
     */          
    public class AccelerateInfo extends MovieClip
    {
        
        private var tfInfo:TextField;        
        private var accelerometer:Accelerometer;        
        
        /**
         *  Constructor 
         * 
         */
        public function AccelerateInfo()
        {
            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;		            

            // Create Text Field     
            tfInfo = new TextField();
            var format:TextFormat = new TextFormat("Helvetica", 26);
            format.color = 0xfffffff; 
            tfInfo.defaultTextFormat = format;
            tfInfo.border = true;
            tfInfo.wordWrap = true;
            tfInfo.multiline = true;
            tfInfo.background = true; 
            tfInfo.backgroundColor = 0xFF5500; 
            tfInfo.x = 0;
            tfInfo.y = 0;
            tfInfo.height = stage.stageHeight;
            tfInfo.width = stage.stageWidth;            
            addChild(tfInfo);            
        
            // Determine Accelerator support 
            if (Accelerometer.isSupported) 
            {
                accelerometer = new Accelerometer(); 
                accelerometer.setRequestedUpdateInterval(500); 
                accelerometer.addEventListener(AccelerometerEvent.UPDATE, accelerometerUpdateHandler);
            }    
            else
            {
                tfInfo.text = "Motion sensor detection is not support on this device. No Accelerator for you!"; 
            }    
            
        }

    
        /**
         * Handler for Accelerometer updates  
         */
        private function accelerometerUpdateHandler(event:AccelerometerEvent):void
        {
            
            var s:String = "X:" + event.accelerationX.toString() + "\n" + 
                           "Y:" + event.accelerationY.toString() + "\n" + 
                           "Z:" + event.accelerationZ.toString() + "\n" + 
                           "Duration:" + event.timestamp.toString() + "\n"; 
            
            tfInfo.text = s; 
            
        }
    
    
    }
}