﻿package
{
    import com.richwagner.Spheres.Sphere;
    
    import flash.display.MovieClip;
    import flash.display.StageAlign;
    import flash.display.StageScaleMode;
    import flash.events.AccelerometerEvent;
    import flash.events.Event;
    import flash.events.TimerEvent;
    import flash.media.Sound;
    import flash.media.SoundChannel;
    import flash.net.URLRequest;
    import flash.sensors.Accelerometer;
    import flash.utils.Timer;



    /**
     * Document class for SphereAcceleration application. 
     * iPhone Development with Flash sample app 
     * 
     * @author Rich Wagner
     * 
     */     
    public class SphereAcceleration extends MovieClip
    {
  
        private var accelerometer:Accelerometer;           
        private var sphere:Sphere;     

        //private var soundUrl:String = "bounce.mp3";
        //private var sound:SoundChannel;   
        //private var soundFactory:Sound; 
        
        /**
         * Constructor  
         * 
         */
        public function SphereAcceleration()
        {

            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;	

            createSphere(50, 0x65c8c6); 
            
            //var request:URLRequest = new URLRequest(soundUrl);
            //soundFactory = new Sound();
            //soundFactory.load(request);
            
            // Determine Accelerator support 
            if (Accelerometer.isSupported) 
            {
                accelerometer = new Accelerometer(); 
                accelerometer.addEventListener(AccelerometerEvent.UPDATE, accelerometerUpdateHandler);

                addEventListener(Event.ENTER_FRAME, onEnterFrame);  
                
            }    
            else
            {
                trace("Motion sensor detection is not support on this device. No Accelerator for you!");  
            }  
            
        }
        
         
        private function onEnterFrame(event:Event):void  
        {  
            roll(); 
        }          
         
        
        private function createSphere(size:Number, color:Number):void
        {
            sphere = new Sphere(size, color); 
            sphere.x = (stage.stageWidth / 2);
            sphere.y = (stage.stageHeight / 2);
            sphere.cacheAsBitmap = true; 
            addChild(sphere); 
        }
        
        /**
         * Handler for Accelerometer updates  
         */
        private function accelerometerUpdateHandler(event:AccelerometerEvent):void
        {
            sphere.xSpeed += event.accelerationX * 2;
            sphere.ySpeed -= event.accelerationY * 2;        
        }        

        
        private function roll():void
        {
            var sphereRadius:Number = 25; 
            
            var newX:Number = sphere.x + sphere.xSpeed;
            var newY:Number = sphere.y + sphere.ySpeed;
            
            // Left side boundary 
            if (newX < sphereRadius)
            {
                //sound = soundFactory.play();            
                sphere.x = sphereRadius;
                sphere.xSpeed *= -0.5;
            }
            // Right side boundary 
            else if (newX > stage.stageWidth - sphereRadius)
            {
                //sound = soundFactory.play();            
                sphere.x = stage.stageWidth - sphereRadius;
                sphere.xSpeed *= -0.5;
            }
            // Otherwise, go at normal speed
            else
            {
                sphere.x += sphere.xSpeed;
            }
            
            // Top boundary 
            if (newY < sphereRadius)
            {
                //sound = soundFactory.play();            
                sphere.y = sphereRadius;
                sphere.ySpeed *= -0.5;
            }
            // Bottom boundary 
            else if (newY > stage.stageHeight - sphereRadius)
            {
                //sound = soundFactory.play();            
                sphere.y = stage.stageHeight - sphereRadius;
                sphere.ySpeed *= -0.5;
            }
            // Otherwise, go at normal speed
            else
            {
                sphere.y += sphere.ySpeed;
            }

        }    
        
        
    }
}