﻿package
{
    import flash.display.Bitmap;
	import flash.display.MovieClip;
    import flash.display.Sprite;
    import flash.events.TouchEvent;
    import flash.events.TransformGestureEvent;
    import flash.geom.Matrix;
    import flash.text.TextField;
    import flash.text.TextFormat;
    import flash.ui.Multitouch;
    import flash.ui.MultitouchInputMode;

    /**
     * Document class for VanillaApp application. 
     * Sample application 
     *  
     * @author Rich Wagner
     * 
     */    
    public class VanillaApp extends MovieClip
    {
        
        // External image 
        [Embed(source="Mini.jpg")]
        private var MiniImage:Class;
        
        // TextField 
        private var tfInfo:TextField;
        
        // Constants 
        private const VIEWPORT_WIDTH:int = 480;
        private const VIEWPORT_HEIGHT:int = 800;
        private const IMG_WIDTH:uint = 1000;
        private const IMG_HEIGHT:uint = 760;        

        /**
         * Constructor  
         * 
         */        
        public function VanillaApp()
        {
            super();

            // Format text field 
            var tf:TextFormat = new TextFormat();
            tf.color = 0xffffff;
            tf.font = "Helvetica";
            tf.bold = true; 
            tf.size = 20;
            
            // Create textfield 
            tfInfo = new TextField();
            tfInfo.width = 470;
            tfInfo.defaultTextFormat = tf;
            tfInfo.x = 2;
            tfInfo.y = 20;
            tfInfo.selectable = false;
            tfInfo.text = "Welcome to VanillaApp. Zoom or pan to begin.";
            stage.addChild(tfInfo);        
        
            // Create bitmap     
            var bitmap:Bitmap = new MiniImage();
            bitmap.smoothing = true;
                        
            // Create sprite container for image 
            var sprite:Sprite = new Sprite();
            sprite.addChild(bitmap);

            // Scaling and positioning     
            var fx:Number = VIEWPORT_WIDTH / IMG_WIDTH;
            sprite.scaleX = fx;
            sprite.scaleY = fx;
            sprite.x = VIEWPORT_WIDTH / 2;
            sprite.y = VIEWPORT_HEIGHT / 2;
            bitmap.x = (IMG_WIDTH - (IMG_WIDTH / 2)) * -1;
            bitmap.y = (IMG_HEIGHT - (IMG_HEIGHT / 2)) *-1;
            
            addChild(sprite);
            
            // Set input mode 
            Multitouch.inputMode = MultitouchInputMode.GESTURE;
            
            // Assign event handlers 
            sprite.addEventListener(TransformGestureEvent.GESTURE_ZOOM, zoomHandler);
            sprite.addEventListener(TransformGestureEvent.GESTURE_PAN, panHandler);
            //sprite.addEventListener(TouchEvent.TOUCH_TAP, touchTapHandler);
            
        }
                
        /**
         * Handler for Zoom events 
         *  
         * @param event
         * 
         */        
        private function zoomHandler(event:TransformGestureEvent):void
        {
            tfInfo.text = "Zoom event";

            var sprite:Sprite = event.target as Sprite;
            sprite.scaleX *= event.scaleX;
            sprite.scaleY *= event.scaleY;
        }
        
        /**
         * Handler for Pan events 
         *  
         * @param event
         * 
         */
        private function panHandler(event:TransformGestureEvent):void
        {
            tfInfo.text = "Pan event";
            
            var sprite:Sprite = event.target as Sprite;
            sprite.x += event.offsetX;
            sprite.y += event.offsetY;
            
        }    

        /**
         * Handler for Touch Tap events 
         *  
         * @param event
         * 
         */        
        private function touchTapHandler(event:TouchEvent):void
        {
            tfInfo.text = "Touch event";
            
            var sprite:Sprite = event.target as Sprite;
            sprite.scaleX = .25;
            sprite.scaleY = .25;
            
            sprite.x = VIEWPORT_WIDTH / 2;
            sprite.y = VIEWPORT_HEIGHT / 2;
            
        }        
    }
}