﻿package  {
	
	import flash.display.Bitmap;
    import flash.display.Sprite;
    import flash.display.MovieClip;
	import flash.events.TransformGestureEvent;
    import flash.geom.Matrix;
    import flash.ui.Multitouch;
    import flash.ui.MultitouchInputMode;	
    import flash.events.Event;		
	import flash.geom.Point;	
	
    /**
     * Document class for GestureMania application. 
     * Sample application 
     *  
     * @author Rich Wagner
     * 
     */     
	public class GestureMania extends MovieClip 
	{
		
		
        // External image 
        [Embed(source="waterfront.jpg")]
        private var WaterFrontImage:Class;		
		
		private var pic:Bitmap; 
		private var picSprite:Sprite; 
		
        /**
         * Constructor  
         * 
         */	        
		public function GestureMania() 
		{
		
			// Create bitmap     
			pic= new WaterFrontImage();
			pic.smoothing = true;
			pic.scaleX = 1.3; 
			pic.scaleY = 1.3; 
			
			// Create sprite container for image 
			picSprite = new Sprite();
			picSprite.addChild(pic);
		
			// Add to stage 		
			addChild(picSprite);
		
			// Center picture 
			pic.x = stage.stageWidth/2 - pic.width/2;
			pic.y = stage.stageHeight/2 - pic.height/2;
		
			// If support multitouch 
			if (Multitouch.supportsTouchEvents)
			{	
				Multitouch.inputMode = MultitouchInputMode.GESTURE;
				picSprite.addEventListener(TransformGestureEvent.GESTURE_ZOOM, GestureZoomHandler);
				picSprite.addEventListener(TransformGestureEvent.GESTURE_ROTATE, GestureRotateHandler);
			}
		}


        /**
         * Handler for Zoom event 
         *  
         * @param event
         * 
         */        
		private function GestureZoomHandler(event:TransformGestureEvent):void
		{
            // Zoom in proportion to gesture 
			pic.scaleX *=  event.scaleX;
			pic.scaleY *= event.scaleY;
			
            // Always reset picture to center 
            pic.x = stage.stageWidth/2 - pic.width/2;
            pic.y = stage.stageHeight/2 - pic.height/2;			
		}
		
		
        /**
         * Handler for Rotate event 
         *  
         * @param event
         * 
         */        
		private function GestureRotateHandler(event:TransformGestureEvent):void
		{
			 var matrix:Matrix = picSprite.transform.matrix;
			 var rotatePoint:Point = matrix.transformPoint(new Point((picSprite.width/2), (picSprite.height/2)));
			 matrix.translate(-rotatePoint.x, -rotatePoint.y);
			 matrix.rotate(event.rotation*(Math.PI/180));
			 matrix.translate(rotatePoint.x, rotatePoint.y);
			 picSprite.transform.matrix = matrix;
		}
		

		
		
	}
}

