﻿package  {
	
    import flash.display.Bitmap;
    import flash.display.Sprite;
    import flash.events.TouchEvent;
    import flash.ui.Multitouch;
    import flash.ui.MultitouchInputMode;	
 	import flash.display.Loader;
    import flash.events.Event;	
	
	
    /**
     * Document class for PhotoTouch application. 
     * Sample application 
     *  
     * @author Rich Wagner
     * 
     */        
	public class PhotoTouch extends Sprite 
    {
		
        // External image 
        [Embed(source="waterfront.jpg")]
        private var WaterFrontImage:Class;		
		
        [Embed(source="fallroad.jpg")]
        private var RoadImage:Class;		
		
		
		private var pic:Bitmap; 
		private var pic2:Bitmap; 
		

        /**
         * Constructor  
         * 
         */		
		public function PhotoTouch() 
		{
			
            // Create bitmap     
            pic= new WaterFrontImage();
            pic.smoothing = true;			
			
			pic2= new RoadImage();
            pic2.smoothing = true;			
		
			// Create sprite container for images 
            var picSprite:Sprite = new Sprite();
           	picSprite.addChild(pic);
			var picSprite2:Sprite = new Sprite();
           	picSprite2.addChild(pic2);
			
            // Add to stage             
            addChild(picSprite);
			addChild(picSprite2)

            // Center first picture 
            pic.x = stage.stageWidth/2 - pic.width/2;
            pic.y = stage.stageHeight/2 - pic.height/2;

			// Offset second picture 
			pic2.x = pic.x + 50; 
			pic2.y = pic.y + 50; 
			
			
			if (Multitouch.supportsTouchEvents)
			{	
                // Enable Touch mode 
				Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT; 

                // Assign Touch Event handlers 
				picSprite.addEventListener(TouchEvent.TOUCH_BEGIN, touchBeginHandler);
				addEventListener(TouchEvent.TOUCH_MOVE, touchMoveHandler);
                addEventListener(TouchEvent.TOUCH_END, touchEndHandler);
				//picSprite.addEventListener(TouchEvent.TOUCH_TAP, touchTapHandler);
				

				picSprite2.addEventListener(TouchEvent.TOUCH_BEGIN, touchBeginHandler);
				addEventListener(TouchEvent.TOUCH_MOVE, touchMoveHandler);
                addEventListener(TouchEvent.TOUCH_END, touchEndHandler);
				//picSprite2.addEventListener(TouchEvent.TOUCH_TAP, touchTapHandler);

			}
			
		}
		
        /**
         * Handler for TouchBegin events 
         *  
         * @param event
         * 
         */               
		private function touchBeginHandler(event:TouchEvent) 
		{
			var sprite:Sprite = event.target as Sprite;
			sprite.startTouchDrag(event.touchPointID);
			// Bring to top 
			setChildIndex(sprite, numChildren-1); 
		}
        
        /**
         * Handler for TouchMove events 
         *  
         * @param event
         * 
         */       	
		private function touchMoveHandler(event:TouchEvent) 
		{
			var sprite:Sprite = event.target as Sprite;
			// Set alpha 
            sprite.alpha = 0.7; 

		}

        /**
         * Handler for TouchEnd events 
         *  
         * @param event
         * 
         */       
		private function touchEndHandler(event:TouchEvent) 
		{
			var sprite:Sprite = event.target as Sprite;
			sprite.stopTouchDrag(event.touchPointID);
			// Reset alpha 
			sprite.alpha = 1;
		}
		
        /**
         * Handler for TouchTap events 
         *  
         * @param event
         * 
         */       
		function touchTapHandler(event:TouchEvent) 
		{
			var sprite:Sprite = event.target as Sprite;
			sprite.x = stage.stageWidth/2 - sprite.width/2;
			sprite.y = stage.stageHeight/2 - sprite.height/2;
		}
				
		
		
	}
	
}
