﻿package  {
	
	import flash.display.MovieClip;
	import flash.events.TransformGestureEvent; 
	import flash.events.Event; 
	import flash.ui.Multitouch;
    import flash.ui.MultitouchInputMode;	
    import flash.media.Sound;
	
    
    /**
     * Document class for PhotoPage application. 
     * Sample application 
     *  
     * @author Rich Wagner
     * 
     */        
	public class PhotoPage extends MovieClip {
		
        // SwipeSound is a Flash asset     
		private var swipe:SwipeSound; 

        /**
         * Constructor  
         * 
         */	
		public function PhotoPage() 
		{
            // Need to stop playing of movie since
            // we have multiple frames for this app 
			stop(); 
			
            // Create sound instance 
			swipe = new SwipeSound(); 
            
            // If support multitouch 
            if (Multitouch.supportsTouchEvents)
            {	
			    Multitouch.inputMode = MultitouchInputMode.GESTURE;
			    stage.addEventListener(TransformGestureEvent.GESTURE_SWIPE, swipeHandler);
            }
                
		}
		

        /**
         * Handler for Swipe event 
         *  
         * @param event
         * 
         */  
		private function swipeHandler(event:TransformGestureEvent):void 
		{
							
			// Swipe Left 
			if (event.offsetX == 1 ) 
			{
				if (currentFrame > 1) 
				{
					gotoAndStop(currentFrame-1);
				}
				else 
				{
					gotoAndStop(totalFrames); 
				}
				
			}							
			//Swipe Right 							
			else if (event.offsetX == -1) 
			{
				if (currentFrame < totalFrames) 
				{
					gotoAndStop(currentFrame+1);
				}
				else 
				{
					gotoAndStop(1); 
				}
			}

			swipe.play(); 	

		}
		
	}
	
}
