﻿package
{
    import flash.display.*;
    import flash.display.Sprite;
    import flash.events.*;
    import flash.text.*;
    import fl.controls.Button;
    import fl.controls.Label;
    import fl.controls.LabelButton;
    
    /**
     * Document class for OrientationSimple application. 
     * iPhone Development with Flash sample app 
     *  
     * @author Rich Wagner
     * 
     */        
    public class OrientExpress extends Sprite
    {
        public var tfInfo:TextField;
        public var btnDefault:Button;    
        
        /**
         * Construtor  
         * 
         */
        public function OrientExpress():void		
        {
			// Required property assignments if you want to 
            // manually orient your app 
            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;			
            
            // Set up TextField 
            tfInfo = new TextField();
            var format:TextFormat = new TextFormat("Helvetica", 26);
            format.color = 0xfffffff; 
            tfInfo.defaultTextFormat = format;
            tfInfo.border = true;
            tfInfo.wordWrap = true;
            tfInfo.multiline = true;
            tfInfo.background = true; 
            tfInfo.backgroundColor = 0x7AB900; 
            tfInfo.x = 10;
            tfInfo.y = 10;
            tfInfo.height = stage.stageHeight - 80;
            tfInfo.width = stage.stageWidth - 20;            
            addChild(tfInfo);            

            // Set up Button         
			btnDefault = new Button();
			btnDefault.width = stage.stageWidth-20; 
			btnDefault.height = 44; 
			btnDefault.x = 10; 
			btnDefault.y = stage.stageHeight - 54;
			addChild(btnDefault); 

            try
            {
                tfInfo.text = stage.orientation;
                stage.addEventListener(StageOrientationEvent.ORIENTATION_CHANGE, orientationChangeListener);
            }
            catch(e:Error)
            {
                print("Stage orientation not supported.");
            }
        }
        
        
        /**
         * Listener for orientation changes 
         *  
         * @param event
         * 
         */        
        public function orientationChangeListener(event:StageOrientationEvent):void
        {
            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;	
            
            if(event.afterOrientation)
            {
                if (stage.orientation == StageOrientation.DEFAULT || stage.orientation == StageOrientation.UPSIDE_DOWN)
                {
                    tfInfo.width = stage.stageWidth - 20;
                    tfInfo.height = stage.stageHeight - 80;
					
					btnDefault.x = 10; 
					btnDefault.y = stage.stageHeight - 54;
					btnDefault.width = stage.stageWidth - 20; 
					
                } 
                else if (stage.orientation == StageOrientation.ROTATED_LEFT || stage.orientation == StageOrientation.ROTATED_RIGHT)
                {
                    tfInfo.width = stage.stageWidth - 20; 
                    tfInfo.height = stage.stageHeight - 80; 

					btnDefault.width = stage.stageWidth - 20; 
					btnDefault.x = 10; 
					btnDefault.y = stage.stageHeight - 54; 
                } 
                else
                {

                }    
				
                print("orientation:" + stage.orientation); 
            }
        }            
        
        
        /**
         * Prints specified param to UI 
         *  
         * @param obj
         * 
         */
        public function print(obj:Object):void
        {
            tfInfo.text = obj as String; 
        }

    }        
}