﻿package
{
    import flash.display.MovieClip;
    import flash.display.*;
    import flash.display.Sprite;
    import flash.events.*;
    import flash.text.*;    

    /**
     * Document class for OrientationSimple application. 
     * Android Development with Flash sample app 
     *  
     * @author Rich Wagner
     * 
     */        
    public class OrientationSimple extends Sprite
    {
        public var tfInfo:TextField;
        
        /**
         * Constructor  
         * 
         */
        public function OrientationSimple():void		
        {
            // Required property assignments if you want to 
            // manually orient your app 
            stage.align = StageAlign.TOP_LEFT;
            stage.scaleMode = StageScaleMode.NO_SCALE;			
            
            tfInfo = new TextField();
            var format:TextFormat = new TextFormat("Helvetica", 26);
            format.color = 0xfffffff; 
            tfInfo.defaultTextFormat = format;
            tfInfo.border = true;
            tfInfo.wordWrap = true;
            tfInfo.multiline = true;
            tfInfo.background = true; 
            tfInfo.backgroundColor = 0xFF5500; 
            tfInfo.x = 0;
            tfInfo.y = 0;
            tfInfo.height = stage.stageHeight;
            tfInfo.width = stage.stageWidth;            
            addChild(tfInfo);          
        
            try
            {
                print("Rotate me");
                stage.addEventListener(StageOrientationEvent.ORIENTATION_CHANGE, orientationChangeListener);
            }
            catch(e:Error)
            {
                print("Stage orientation not supported.");
            }        
        
        }    
    
        /**
         * Listener for orientation changes 
         *  
         * @param event
         * 
         */
        public function orientationChangeListener(event:StageOrientationEvent):void
        {
			
			print("Made it"); 

            tfInfo.width = stage.stageWidth;
            tfInfo.height = stage.stageHeight;            
            
            if(event.afterOrientation)
            {
                if (stage.orientation == StageOrientation.DEFAULT ) 
                    print("Portrait"); 
                else if (stage.orientation == StageOrientation.UPSIDE_DOWN)
                    print("Portrait (upside down)")
                else if (stage.orientation == StageOrientation.ROTATED_LEFT ) 
                    print("Landscape (left, screen turned counterclockwise")
                else if (stage.orientation == StageOrientation.ROTATED_RIGHT)
                    print("Landscape (right, screen turned clockwise)"); 
                else
                    print("Where am I? I am totally disoriented"); 
            }
        }            
        
        
        /**
         * Prints specified param to UI 
         *  
         * @param obj
         * 
         */
        public function print(obj:Object):void
        {
            tfInfo.text = obj as String; 
        }        
            
    }
}