﻿package
{

    import flash.display.Sprite;
    import flash.display.StageAlign;
    import flash.display.StageScaleMode;
    import flash.events.GeolocationEvent;
    import flash.sensors.Geolocation;
    import flash.text.TextField;
    import flash.text.TextFormat;    

    /**
     * Document class for Geolocate application. 
     * Sample application for iPhone Development with Flash 
     *  
     * @author Rich Wagner
     * 
     */        
    public class Geolocate extends Sprite
    {

        // Geolocation     
        private var geo:Geolocation;
        
        // TextField 
        private var tfInfo:TextField; 
        
        /**
         * Constructor  
         * 
         */            
        public function Geolocate()
        {

            // Set up the stage     
            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;

            // Create TextField         
            tfInfo = new TextField();
            var format:TextFormat = new TextFormat("Helvetica", 18);
            format.color = 0x000000; 
            tfInfo.defaultTextFormat = format;
            tfInfo.border = true;
            tfInfo.wordWrap = true;
            tfInfo.multiline = true;
            tfInfo.x = 10;
            tfInfo.y = 10;
            tfInfo.height = stage.stageHeight - 20;
            tfInfo.width = stage.stageWidth - 20;
            addChild(tfInfo);
            
            // Is geolocation supported? 
            if (Geolocation.isSupported)
            {
                // If so, set it up 
                geo = new Geolocation();
                geo.setRequestedUpdateInterval(500);
                geo.addEventListener(GeolocationEvent.UPDATE, geolocationUpdateHandler);
                //tfInfo.text =  "OK";  
            }
            // If not, let user know. 
            else
            {
                tfInfo.text =  "No geolocation services available.";
            }

        }

        
        /**
         * Called each time the geolocation services updates app  
         * 
         * @param event
         * 
         */
        private function geolocationUpdateHandler(event:GeolocationEvent):void
        {
            tfInfo.text = "Raw Geolocation Data:\n";
            tfInfo.appendText("Latitude:" +  Math.round(event.latitude).toString() + "°\n");
            tfInfo.appendText("Longitude:" + Math.round(event.longitude).toString() + "°\n");
            tfInfo.appendText("Altitude:" + Math.round(event.altitude).toString() + " m\n");
            tfInfo.appendText("Speed:" + Math.round(event.speed).toString() + " m/s\n");
            tfInfo.appendText("Horizontal Accuracy:" + Math.round(event.horizontalAccuracy).toString() + " m\n");
            tfInfo.appendText("Vertical Accuracy:" + Math.round(event.verticalAccuracy).toString() + " m\n");
            tfInfo.appendText("Heading:" + Math.round(event.heading).toString() + "°");
        }
    
    }

}