﻿package
{
    import flash.display.Bitmap;
    import flash.display.MovieClip;
    import flash.display.Sprite;
    import flash.display.StageAlign;
    import flash.display.StageScaleMode;
    import flash.events.GeolocationEvent;
    import flash.sensors.Geolocation;
    import flash.text.AntiAliasType;
    import flash.text.Font;
    import flash.text.TextField;
    import flash.text.TextFormat;
    import flash.text.engine.FontWeight;
	import flash.events.StatusEvent; 

    /**
     * Document class for Speedometer application. 
     * Sample application 
     *  
     * @author Rich Wagner
     * 
     */       
    public class Speedometer extends flash.display.MovieClip    {
        // Geolocation     
        private var geo:Geolocation;        
        
        // Speed text 
        private var tfSpeed:TextField;       
        private var tfAlt:TextField;       
        
        
        // Background image 
        [Embed(source="bg.jpg")]
        private var BgImage:Class;
        
        [Embed(source='digital-7.ttf', fontName='DigitalSeven', fontWeight="normal", advancedAntiAliasing="true", mimeType="application/x-font")]
        private var digital7:Class;
        
        /**
         * Constructor  
         * 
         */               
        public function Speedometer()
        {
            Font.registerFont(digital7);            

            stage.scaleMode = StageScaleMode.NO_SCALE;
            stage.align = StageAlign.TOP_LEFT;            

            // Digital7 font     
            var digital7Font:Font = new Digital7(); 

            // Add background      
            var bg:Bitmap = new BgImage();
            bg.smoothing = true;
            addChild(bg); 
            
            var format:TextFormat = new TextFormat();
            format.color = 0x000000; 
			format.align = "right"; 
			format.font =  digital7Font.fontName; 
			format.size = 35; 

            // Create TextFields 
            tfSpeed = new TextField();
            tfSpeed.defaultTextFormat = format;
            tfSpeed.selectable = false;
            tfSpeed.antiAliasType = AntiAliasType.ADVANCED;
			tfSpeed.x = 520;
            tfSpeed.y = 290;
            tfSpeed.height = 42;
            tfSpeed.width = 60;
            tfSpeed.text =  "25";
           	tfSpeed.embedFonts = true; 
            addChild(tfSpeed);  

            tfAlt = new TextField();
            tfAlt.defaultTextFormat = format;
            tfAlt.selectable = false; 			
            tfAlt.antiAliasType = AntiAliasType.ADVANCED;
            tfAlt.x = 185;
            tfAlt.y = 290;
            tfAlt.height = 42;
            tfAlt.width = 66;
            tfAlt.text =  "3419";
            tfAlt.embedFonts = true; 
            addChild(tfAlt);  
            
            var format2:TextFormat = new TextFormat();
            format2.color = 0x000000; 
            format2.align = "left"; 
            format2.font =  digital7Font.fontName; 
            format2.size = 12; 
                        
            var tfAltLabel:TextField = new TextField(); 
            tfAltLabel.defaultTextFormat = format2;
            tfAltLabel.selectable = false; 			
            tfAltLabel.antiAliasType = AntiAliasType.ADVANCED;
            tfAltLabel.x = 262;
            tfAltLabel.y = 287;
            tfAltLabel.height = 42;
            tfAltLabel.width = 67;
            tfAltLabel.text =  "m.";
            tfAltLabel.embedFonts = true; 
            addChild(tfAltLabel);  
            
            
            var tfSpeedLabel:TextField = new TextField();
            tfSpeedLabel.defaultTextFormat = format2;
            tfSpeedLabel.selectable = false; 			
            tfSpeedLabel.antiAliasType = AntiAliasType.ADVANCED;
            tfSpeedLabel.x = 595;
            tfSpeedLabel.y = 287;
            tfSpeedLabel.height = 42;
            tfSpeedLabel.width = 63;
            tfSpeedLabel.text =  "mph";
            tfSpeedLabel.embedFonts = true; 
            addChild(tfSpeedLabel);  
            
            
            if (Geolocation.isSupported)
            {
                geo = new Geolocation();
                geo.setRequestedUpdateInterval(300);
                geo.addEventListener(GeolocationEvent.UPDATE, geolocationUpdateHandler);
				geo.addEventListener(StatusEvent.STATUS, geolocationStatusHandler);
            }
            else
            {
				tfSpeed.text = "N/A";  
				tfAlt.text = "N/A";
            }              
            
        }

    
        /**
         * Called each time the geolocation services updates app  
         * 
         * @param event
         * 
         */
        private function geolocationUpdateHandler(event:GeolocationEvent):void
        {
              
              // Speed is returned at meters/second multiplied by 
              // constant to give miles per hour  
              var speed:Number = event.speed * 2.23693629; 
              // Altitude 
              var alt:Number = event.altitude; 
              
              tfSpeed.text = Math.round(speed).toString(); 
              tfAlt.text = Math.round(alt).toString(); 
            
        }        
    
	
        /**
         * Called each time the status changes
         * 
         * @param event
         * 
         */
        private function geolocationStatusHandler(event:StatusEvent):void
        {
            // If user is not allowing updates, then display 
            if (geo.muted)
			{
				tfSpeed.text = "N/A";  
				tfAlt.text = "N/A";
			}
                
        }	
    
    }
}