﻿package
{
    
	import com.richwagner.mobileservices.*; 
	
    import fl.controls.Button;
    import fl.controls.Label;
    import fl.controls.LabelButton;
    import fl.controls.TextInput;
    import flash.events.GeolocationEvent; 
	import flash.sensors.Geolocation; 
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.net.URLRequest;
    import flash.net.navigateToURL;
    import flash.text.*; 
	
    /**
     * Document class for Services application. 
     * Sample application for iPhone Development with Flash 
     *  
     * @author Rich Wagner
     * 
     */      
    public class MapServices extends Sprite
    {
		
	      public var btnAddress:Button;  
          public var btnGPS:Button;        
          public var tiAddress:TextInput; 
          
          public var latitude:Number; 
          public var longitude:Number; 
          
          // Geolocation     
          private var geo:Geolocation;        
          
          /**
           * Constructor  
           * 
           */
          public function MapServices()
          {
          
              // Formatters 
              var format:TextFormat = new TextFormat("Helvetica", 44);
              format.color = 0xfffffff; 
              
              var btnFormat:TextFormat = new TextFormat("Helvetica", 26);
              btnFormat.color = 0x000000; 
              btnFormat.bold = true; 
              
              
              // Create TextInput 
              tiAddress = new TextInput();
              tiAddress.textField.background = true; 
              tiAddress.textField.backgroundColor = 0x7AB900; 
              tiAddress.x = 10;
              tiAddress.y = 10;
              tiAddress.height = 300;
              tiAddress.textField.multiline = true; 
              tiAddress.textField.wordWrap = true; 
              tiAddress.width = stage.stageWidth - 20;
              tiAddress.text = "Address, City, State, Zip";
              tiAddress.setStyle("textFormat", format); 
              tiAddress.addEventListener(MouseEvent.CLICK, tiAddressClickHandler); 
              addChild(tiAddress);  
              
              // Create Service buttons         	
              btnAddress = new Button();
              btnAddress.width = stage.stageWidth-20; 
              btnAddress.height = 44;
              btnAddress.x = 10; 
              btnAddress.alpha = 0.9; 
              btnAddress.label = "Map Address"; 
              btnAddress.setStyle("textFormat", btnFormat); 
              btnAddress.y = tiAddress.y + tiAddress.height + 5;
              btnAddress.addEventListener(MouseEvent.CLICK, btnAddressMouseClickHandler);
              addChild(btnAddress); 			
              
              
              
              btnGPS = new Button();
              btnGPS.width = stage.stageWidth-20; 
              btnGPS.height = 44;
              btnGPS.x = 10; 
              btnGPS.alpha = 0.9; 
              btnGPS.label = "Map by GPS"; 
              btnGPS.setStyle("textFormat", btnFormat); 			
              btnGPS.y = stage.stageHeight - 54;
              btnGPS.addEventListener(MouseEvent.CLICK, btnGPSMouseClickHandler); 
              addChild(btnGPS); 		            
              
              // Stage event handler     
              stage.addEventListener(MouseEvent.CLICK, stageClickHandler); 
              
              
              // Is geolocation supported? 
              if (Geolocation.isSupported)
              {
                  // If so, set it up 
                  geo = new Geolocation();
                  geo.setRequestedUpdateInterval(500);
                  geo.addEventListener(GeolocationEvent.UPDATE, geolocationUpdateHandler);
              }

          }
          
          /**
           * Called each time the geolocation services updates app  
           * 
           * @param event
           * 
           */
          private function geolocationUpdateHandler(event:GeolocationEvent):void
          {
              latitude = event.latitude;
              longitude = event.longitude; 
          }        
          
          /**
           * Shows Google Map of specified address  
           *  
           * @param event
           * 
           */        
          private function btnAddressMouseClickHandler(event:Event):void
          {
              event.stopPropagation();
              GoogleMaps.pointToAddress(tiAddress.text);             
          }
          
          /**
           * Shows Google Map based on current latitude, longitude coordinates 
           * 
           * @param event
           * 
           */        
          private function btnGPSMouseClickHandler(event:Event):void
          {
              event.stopPropagation();
              GoogleMaps.pointToCoordinates(latitude, longitude); 
          }       
          
          
          /**
           * Click handler for Text Input 
           *  
           * @param event
           * 
           */
          private function tiAddressClickHandler(event:Event):void
          {
              event.stopPropagation();
          }
          
          
          /**
           * Click handler for stage 
           *  
           * @param event
           * 
           */
          private function stageClickHandler(event:Event):void
          {
              btnAddress.setFocus();                 
          }    
                  
        
    }
}