package app.views
{
    import com.richwagner.mobileservices.PhoneDialer;
    import com.richwagner.mobileservices.SMS;
    
    import fl.controls.Button;
    import fl.controls.Label;
    import fl.controls.LabelButton;
    import fl.controls.TextInput;
    
    import flash.display.Sprite;
    import flash.events.Event;
    import flash.events.MouseEvent;
    import flash.net.URLRequest;
    import flash.net.navigateToURL;
    import flash.text.*; 
    
    /**
     * Document class for Services application. 
     * Sample application for iPhone Development with Flash 
     *  
     * @author Rich Wagner
     * 
     */      
    public class PhoneServices extends Sprite
    {
        
        public var tiNumber:TextInput; 
        public var btnPhone:Button;  
        public var btnSMS:Button; 
        
        /**
         * Constructor  
         * 
         */        
        public function PhoneServices()
        {
            
            // Formatters 
            var format:TextFormat = new TextFormat("Helvetica", 44);
            format.color = 0xfffffff; 
            
            var btnFormat:TextFormat = new TextFormat("Helvetica", 32);
            btnFormat.color = 0x000000; 
            btnFormat.bold = true; 
            
            
            // Create TextInput 
            tiNumber = new TextInput();
            tiNumber.textField.background = true; 
            tiNumber.textField.backgroundColor = 0x7AB900; 
            tiNumber.x = 10;
            tiNumber.y = 10;
            tiNumber.height = 60;
            tiNumber.textField.multiline = true; 
            tiNumber.textField.wordWrap = true; 
            tiNumber.width = stage.stageWidth - 20;
            tiNumber.text = "978-270-1889";
            tiNumber.setStyle("textFormat", format); 
            tiNumber.addEventListener(MouseEvent.CLICK, tiNumberClickHandler); 
            addChild(tiNumber);  
            
            // Create Service buttons         	
            btnPhone = new Button();
            btnPhone.width = stage.stageWidth-20; 
            btnPhone.height = 44;
            btnPhone.x = 10; 
            btnPhone.alpha = 0.9; 
            btnPhone.label = "Call"; 
            btnPhone.setStyle("textFormat", btnFormat); 
            btnPhone.y = stage.stageHeight - 54;
            btnPhone.addEventListener(MouseEvent.CLICK, btnPhoneMouseClickHandler);
            addChild(btnPhone); 			
            
            btnSMS = new Button();
            btnSMS.width = stage.stageWidth-20; 
            btnSMS.height = 44;
            btnSMS.x = 10; 
            btnSMS.alpha = 0.9; 
            btnSMS.label = "Send SMS"; 
            btnSMS.setStyle("textFormat", btnFormat); 			
            btnSMS.y = stage.stageHeight - 104;
            btnSMS.addEventListener(MouseEvent.CLICK, btnSMSMouseClickHandler); 
            addChild(btnSMS); 
            
            
            // Stage event handler     
            stage.addEventListener(MouseEvent.CLICK, stageClickHandler); 
            
        }
        
        
        /**
         * Dials phone 
         *  
         * @param event
         * 
         */        
        private function btnPhoneMouseClickHandler(event:Event):void
        {
            event.stopPropagation();
            PhoneDialer.dial(tiNumber.text);       
        }
        
        /**
         * Open SMS Message window 
         * 
         * @param event
         * 
         */        
        private function btnSMSMouseClickHandler(event:Event):void
        {
            event.stopPropagation();
            SMS.send(tiNumber.text);          
        }       
        
        
        /**
         * Click handler for Text Input 
         *  
         * @param event
         * 
         */
        private function tiNumberClickHandler(event:Event):void
        {
            event.stopPropagation();
        }
        
        
        /**
         * Click handler for stage 
         *  
         * @param event
         * 
         */
        private function stageClickHandler(event:Event):void
        {
            btnPhone.setFocus();                 
        }    
        
    }
}