﻿package  com.kevinhoyt.components
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormatAlign;
	
	public class CheckBox extends Sprite 
	{
		private var _selected:Boolean = false;
		private var _label:String = null;
		
		public function CheckBox( label:String = "All day", selected:Boolean = false ) 
		{
			super();
			_label = label;
			_selected = selected;
			addEventListener( Event.ADDED_TO_STAGE, doAdded );
		}
		
		protected function doAdded( event:Event ):void
		{
			hit.alpha = 0;
			
			field.defaultTextFormat = new TextFormat( "Droid Sans", 28, 0x000000, null, null, null, null, null, TextFormatAlign.RIGHT );
			field.autoSize = TextFieldAutoSize.RIGHT;
			
			if( _label == null )
			{
				field.text = "";
			} else {
				field.text = _label;
			}
			
			if( _selected )
			{
				sup.visible = true;
				uup.visible = false;
			} else {
				sup.visible = false;
				uup.visible = true;
			}
			
			sdown.visible = false;
			udown.visible = false;
			
			down.visible = false;
			
			hit.addEventListener( MouseEvent.MOUSE_DOWN, doMouseDown );
			hit.addEventListener( MouseEvent.MOUSE_UP, doMouseUp );
		}
		
		protected function doMouseDown( event:MouseEvent ):void
		{
			if( !_selected )
			{
				uup.visible = false;
				udown.visible = true;
			} else {
				sup.visible = false;
				sdown.visible = true;
			}
			
			down.visible = true;
			up.visible = false;			
		}
		
		protected function doMouseUp( event:MouseEvent ):void
		{
			if( !_selected )
			{
				sup.visible = true;
				udown.visible = false;
			} else {
				uup.visible = true;
				sdown.visible = false;
			}
			
			up.visible = true;						
			down.visible = false;
			
			_selected = !_selected;
		}		
		
		public function get label():String
		{
			return _label;
		}
		
		public function set label( value:String ):void
		{
			_label = value;
			
			if( value == null )
			{
				field.text = "";
			} else {
				field.text = value;
			}
		}
		
		public function get selected():Boolean
		{
			return _selected;
		}
		
		public function set selected( value:Boolean ):void
		{
			_selected = value;
			
			if( _selected )
			{
				sup.visible = true;
				uup.visible = false;
			} else {
				uup.visible = true;
				sup.visible = false;
			}
		}
	}
}
