﻿package com.kevinhoyt.components 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;

	public class DateDialog extends Sprite 
	{
		private var _date:Date = null;
		
		public function DateDialog() 
		{
			super();
			addEventListener( Event.ADDED_TO_STAGE, doAdded );
		}
		
		public static function formatShort( value:Date ):String
		{
			var days:Array = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
			var months:Array = [
				"Jan", "Feb", "Mar", "Apr", "May", "Jun",
				"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
			];
			
			return days[value.day] + ", " + months[value.month] + " " + value.date + ", " + value.fullYear;
		}		
		
		private function range():void
		{
			var count:Date = new Date( _date.fullYear, month.index, 20 );
			
			while( count.month == month.index )
			{
				count.date = count.date + 1;
			}
			
			count.date = count.date - 1;
			
			day.minimum = 1;
			day.maximum = count.date;
			
			if( day.current > count.date )
			{
				day.current = count.date;
			}
		}
		
		protected function doAdded( event:Event ):void
		{
			month.addEventListener( StepperEvent.CHANGE, doStepperChange );
			day.addEventListener( StepperEvent.CHANGE, doStepperChange );			
			year.addEventListener( StepperEvent.CHANGE, doStepperChange );
			
			ok.label = "Set";
			ok.addEventListener( MouseEvent.CLICK, doOkClick );
			
			cancel.label = "Cancel";
			cancel.addEventListener( MouseEvent.CLICK, doCancelClick );
		}
		
		protected function doOkClick( event:MouseEvent ):void
		{
			dispatchEvent( new DialogEvent( DialogEvent.OK ) );
		}
		
		protected function doCancelClick( event:MouseEvent ):void
		{
			dispatchEvent( new DialogEvent( DialogEvent.CANCEL ) );
		}		
		
		protected function doStepperChange( event:StepperEvent ):void
		{
			range();
			
			_date.fullYear = year.current;
			_date.date = day.current;			
			_date.month = month.index;
			
			title.text = DateDialog.formatShort( _date );
		}
		
		public function get date():Date
		{
			return _date;
		}
		
		public function set date( value:Date ):void
		{
			if( value == null )
			{
				_date = new Date();
			} else {
				_date = new Date( value.time );
			}
			
			range();
			day.current = value.date;
			
			month.index = value.month;			
			year.current = value.fullYear;
			
			title.text = DateDialog.formatShort( value );
		}		
	}
}
