﻿package com.kevinhoyt.components 
{
	import flash.display.Sprite;
	import flash.events.Event;
	
	import com.greensock.TweenMax;

	public class ListPicker extends Sprite
	{
		public function ListPicker() 
		{
			super();
			addEventListener( Event.ADDED_TO_STAGE, doAdded );
		}
		
		public function show( items:Array, title:String = null ):void
		{
			if( title != null )
			{
				dlg.title = title;
			}
			
			dlg.items = items;
		}
		
		protected function doAdded( event:Event ):void 
		{
			block.alpha = 0;
			block.visible = false;
			
			dlg.visible = false;
			dlg.addEventListener( ListEvent.CLICK, doListClick );
			dlg.addEventListener( ListEvent.RENDERED, doListRendered );
		}
		
		protected function doListClick( event:ListEvent ):void
		{
			dlg.visible = false;			
			
			TweenMax.to( block, 0.35, {
				alpha: 0,
				visible: false
			} );													
		}
		
		protected function doListRendered( event:ListEvent ):void
		{
			event.stopImmediatePropagation();
			
			block.alpha = 0;
			block.visible = true;

			dlg.alpha = 1;
			dlg.visible = true;
			
			TweenMax.to( block, 0.35, {
				alpha: 1	
			} );							
		}
		
		public function get items():Array
		{
			return dlg.items;
		}
		
		public function set items( value:Array ):void
		{
			dlg.items = value;
		}
		
		public function get title():String
		{
			return dlg.title;
		}
		
		public function set title( value:String ):void
		{
			dlg.title = value;
		}		
	}
}
