﻿package com.kevinhoyt.components 
{	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.display.Loader;
	import flash.net.URLRequest;
	import flash.events.MouseEvent;

	public class MenuItem extends Sprite
	{
		private var icon:Loader = null;
		private var _width:Number = 0;
		private var _path:String = null;
		
		public function MenuItem(path:String, label:String, width:Number = 236 ) 
		{
			super();
			_width = width;
			_path = path;
			field.text = label;
			addEventListener(Event.ADDED_TO_STAGE, doAdded );
		}
		
		protected function doAdded( event:Event ):void
		{
			down.visible = false;
			down.width = _width;
			
			hit.width = _width;
			field.width = _width;
			
			icon = new Loader();
			icon.contentLoaderInfo.addEventListener( Event.COMPLETE, doIconComplete );
			icon.visible = false;
			icon.load( new URLRequest( _path ) );
			addChildAt( icon, numChildren - 1 );
			
			addEventListener( MouseEvent.MOUSE_DOWN, doMouseDown );
			addEventListener( MouseEvent.MOUSE_UP, doMouseUp );
		}
		
		protected function doIconComplete( event:Event ):void
		{
			icon.x = Math.round( ( _width - icon.width ) / 2 );
			icon.y = Math.round( ( 74 - icon.height ) / 2 );
			icon.visible = true;
		}
		
		protected function doMouseDown( event:MouseEvent ):void
		{
			down.visible = true;
		}
		
		protected function doMouseUp( event:MouseEvent ):void
		{
			down.visible = false;
		}		
		
		public function get label():String
		{
			return field.text;
		}
		
		public function set label( value:String ):void
		{
			field.text = value;
		}
	}
}
