﻿package com.kevinhoyt.components
{	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FocusEvent;
	import flash.events.MouseEvent;

	public class TextInput extends Sprite 
	{
		public static const COLOR:Number = 0x838183;
		
		private var _width:Number = 0;
		private var _label:String = null;
		
		public function TextInput( label:String = null, width:Number = 460 ) 
		{
			super();
			_label = label;			
			_width = width;
			addEventListener( Event.ADDED_TO_STAGE, doAdded );
		}

		protected function doAdded( event:Event ):void
		{
			up.width = _width - 6;
			
			down.width = _width;
			down.visible = false;
			
			focus.width = _width;
			focus.visible = false;
			
			field.width = _width - 28;
			
			if( _label != null )
			{
				field.text = _label;
			} else {
				field.text = "";
			}
			
			field.addEventListener( FocusEvent.FOCUS_IN, doFocusIn );
			field.addEventListener( FocusEvent.FOCUS_OUT, doFocusOut );
			
			// TODO: Programmatic set focus need for mouse down
		}
		
		protected function doFocusIn( event:FocusEvent ):void
		{
			focus.visible = true;
			
			if( _label != null )
			{
				if( field.textColor == COLOR )
				{
					field.text = "";
				}
			}
			
			field.textColor = 0x000000;			
		}
		
		protected function doFocusOut( event:FocusEvent ):void
		{
			focus.visible = false;
			
			if( _label != null )
			{
				if( field.text.length == 0 )
				{
					field.text = _label;
					field.textColor = COLOR;
				}
			}
		}
	}	
}
